#!/usr/bin/python3

from collections import defaultdict

def nova_farba(farba, zakazana = None):
    # vrati farbu inu od tej povodnej a pripadnej zakazanej
    # bezi v konstantnom case, cyklus spravi max 2 iteracie
    while True:
        farba = (farba + 1) % 10**9
        if farba != zakazana: return farba

# nacitame vstup 

typ = int( input() )
N, dni = [ int(_) for _ in input().split() ]
plot = [ int(_) for _ in input().split() ]

# osetrime pripad N = 1: len dokola prefarbujeme

if N == 1:
    print( 1 )
    for d in range(dni):
        plot[0] = nova_farba( plot[0] )
        print( 0, plot[0] )
    exit()

# zistime najvacsi pocet usekov jednej farby

pocet = defaultdict(int)
for farba in plot: pocet[farba] += 1
najviac = max( pocet.values() )
najcastejsia = next( farba for farba in pocet if pocet[farba] == najviac )

# osetrime pripad, kedy si treba pokazit jednofarebny plot

if najviac == N and dni == 1:
    print( N-1 )
    print( 0, nova_farba( plot[0] ) )
    exit()

# osetrime pripad, kedy si pokazime a opravime jednofarebny plot

if najviac == N:
    print( N )
    for i in range(dni-1):
        plot[0] = nova_farba( plot[0], najcastejsia )
        print( 0, plot[0] )
    if dni > 0:
        print( 0, najcastejsia )
    exit()

# osetrime vsetky ostatne pripady, kedy mame dost dni na ofarbenie celeho plota

if dni >= N - najviac:
    print( N )
    ina = next( i for i in range(N) if plot[i] != najcastejsia )
    # ak treba, nadbytocne dni minieme zbytocnou pracou
    while dni > N - najviac:
        dni -= 1
        plot[ina] = nova_farba( plot[ina], najcastejsia )
        print( ina, plot[ina] )
    # a teraz vsetko natrieme spravne
    for i in range(N):
        if plot[i] != najcastejsia:
            print( i, najcastejsia )
    exit()

# a teraz nam uz ostava len pripad, ze nemame dost dni na cely plot
# a teda sa snazime najst najdlhsi usek ktory este vieme zmenit na jednofarebny

max_od, max_do = 0, 0

# pre kazdu farbu si pamatame, kolkokrat je v aktualnom useku
histogram = defaultdict(int)
for farba in plot: histogram[farba] = 0

# pre kazdy pocet si pamatame, kolko farieb ho momentalne ma
aggregate = defaultdict(int)
aggregate[0] = len(histogram)

od, do, max_pocet = 0, 0, 0

while True:
    if do - od - max_pocet <= dni:
        # aktualny usek je dobry
        # pozrieme, ci nemame rekord
        if do - od > max_do - max_od: max_od, max_do = od, do
        # skusime ho predlzit o prvok plot[do]
        if do == N: break
        aggregate[ histogram[ plot[do] ] ] -= 1
        histogram[ plot[do] ] += 1
        aggregate[ histogram[ plot[do] ] ] += 1
        max_pocet = max( max_pocet, histogram[ plot[do] ] )
        do += 1
    else:
        # aktualny usek je zly, skratime ho o plot[od]
        aggregate[ histogram[ plot[od] ] ] -= 1
        histogram[ plot[od] ] -= 1
        aggregate[ histogram[ plot[od] ] ] += 1
        if aggregate[max_pocet] == 0: max_pocet -= 1
        od += 1

# uz vieme, ktory je najlepsi usek, a treba ho len prefarbit

print( max_do - max_od )

pocet = defaultdict(int)
for farba in plot[max_od:max_do]: pocet[farba] += 1
najviac = max( pocet.values() )
najcastejsia = next( farba for farba in pocet if pocet[farba] == najviac )

for i in range(max_od, max_do):
    if plot[i] != najcastejsia:
        print( i, najcastejsia )

